<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs" :large="false">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Dashboard Supervisión Mantenimiento</strong>
    </div>
    <div class="cotm">
      <div class="tmod">
        <strong
          >Dashboard Supervisión Mantenimiento -
          {{ this.datosTerritorio.territorio }}</strong
        >
      </div>
    </div>
    <!-- Contenido -->
    <div class="contSecc">
      <div class="contenedorPrincipal">
        <v-row>
          <v-col>
            <div class="titSec">Descargar Informe de Territorio</div>
            <div style="margin: 25px 10px 50px 10px">
              <v-btn
                color="primary"
                dark
                @click="downExcel()"
                class="btnDisabled"
              >
                <strong style="fond-size : 16px; color:  #000;"
                  >Descargar a Excel</strong
                >
              </v-btn>
            </div>
          </v-col>
        </v-row>
        <v-row>
          <v-col :cols="12" :md="6" class="pl-8">
            <div class="titSec">Cobertura trimestral de supervisiones</div>
            <div class="gris">
              <div style="height: 20"></div>

              <grafica-media-circular-sup-mto
                ref="mediaCircular"
                :name_id="valores1.filtros.name_id"
              />
              <grafica-barra-horizontal-sup-mto
                hidden="true"
                ref="barraHorizontal"
                :name_id="valores2.filtros.name_id"
              />

              <Semaforo />
            </div>
          </v-col>
          <v-col :cols="12" :md="6" class="pr-8">
            <div class="titSec">
              Comparativa de cobertura semana actual vs semanas anteriores
            </div>
            <div class="gris">
              <grafica-barras-comparativa-semana-sup-mto
                ref="barraComparativaSemana"
                :name_id="valores3.filtros.name_id"
              />
            </div>
          </v-col>
        </v-row>
        <div class="titSec">Supervisiones del trimestre</div>
        <v-card>
          <tabla-usuarios-semanales-sup-mto ref="tablaUsuariosSemanales" />
        </v-card>
      </div>
    </div>
    <!-- Fin conSecc -->
  </div>
</template>

<script>
import store from "@/store";
import axios from "axios";
const serviceCommons = store.state.serviceCommons;
import GraficaMediaCircularSupMto from "@/views/secure/supervision-mantenimiento/dashboard/componentes/GraficaMediaCircularSupMto.vue";
import GraficaBarraHorizontalSupMto from "@/views/secure/supervision-mantenimiento/dashboard/componentes/GraficaBarraHorizontalSupMto.vue";
import GraficaBarrasComparativaSemanaSupMto from "@/views/secure/supervision-mantenimiento/dashboard/componentes/GraficaBarrasComparativaSemanaSupMto.vue";
import TablaUsuariosSemanalesSupMto from "@/views/secure/supervision-mantenimiento/dashboard/componentes/TablaUsuariosSemanalesSupMto.vue";
import Semaforo from "@/views/secure/supervision-mantenimiento/dashboard/componentes/Semaforo.vue";
import FileSaver from "file-saver";

export default {
  components: {
    GraficaMediaCircularSupMto,
    GraficaBarraHorizontalSupMto,
    GraficaBarrasComparativaSemanaSupMto,
    TablaUsuariosSemanalesSupMto,
    Semaforo,
  },
  name: "supervision_mantenimiento_dashboard_segundo_nivel",
  data() {
    return {
      colores: ["#ff0000", "#ffcd00", "#19d228"],
      rangos: ["0,50", "51,89", "90,100"],
      objetoRangos: null,
      methodsSemaforo: null,
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Supervisión Mantenimiento",
          disabled: false,
          exact: true,
          to: {
            name: "supervision_mantenimiento_asignaciones_home",
          },
        },
        {
          text: "Dashboard Supervisión Mantenimiento",
          disabled: false,
          exact: true,
          to: {
            name:
              "supervision_mantenimiento_dashboard_primer_nivel_mantenimiento_supervision",
          },
        },
        {
          text: "Dashboard Supervisión Mantenimiento Territorio",
          disabled: true,
        },
      ],

      fechasTrimestral: {
        territorio: 0,
        fechaInicio: "",
        fechaFin: "",
      },
      datosTerritorio: {
        territorio: "",
        idTerritorio: 0,
        responsable: "",
        valueTrimestre: 0,
        targetTrimestre: 0,
        valueAldia: 0,
        targetAldia: 0,
        rangoSemanas: null,
      },
      paramsNivel_2: "",
      valores1: {
        filtros: {
          name_id: "mediaCircular",
          value: 0,
          target1: 0,
          target2: 0,
          datos: [
            "Supervisiones del territorio realizadas al trimestre",
            "Supervisiones programadas al trimestre",
          ],
          styleObject: {
            width: "100%",
            height: "310px",
            margin: "auto",
          },
          rColores: this.colores,
          rCalf: this.rangos,
        },
      },
      valores2: {
        filtros: {
          value: 0,
          target: 0,
          categoria: "Categoria",
          name_id: "barraHorizontal",
          datos: [
            "Supervisiones realizadas al dia de hoy",
            "Supervisiones programadas al dia de hoy",
          ],
          styleObject: {
            width: "50%",
            height: "105px",
            margin: "auto",
          },
          rColores: this.colores,
          rCalf: this.rangos,
        },
      },
      valores3: {
        filtros: {
          value: 0,
          target: 0,
          categoria: "",
          name_id: "barraComparativaSemana",
          datos: [],
          styleObject: {
            width: "100%",
            height: "410px",
            margin: "auto",
          },
          rColores: this.colores,
          rCalf: this.rangos,
        },
      },
    };
  },
  methods: {
    iniciaGrafica() {
      if (
        this.datosTerritorio.valueTrimestre != 0 &&
        this.datosTerritorio.targetTrimestre != 0 &&
        this.datosTerritorio.targetAldia != 0
      ) {
        this.valores1.filtros.value = this.datosTerritorio.valueTrimestre;
        this.valores1.filtros.target1 = this.datosTerritorio.targetTrimestre;
        this.valores1.filtros.target2 = this.datosTerritorio.targetAldia;
        this.valores1.filtros.rColores = this.colores;
        this.valores1.filtros.rCalf = this.rangos;
        this.$refs.mediaCircular.setValores(this.valores1.filtros);
      }
      if (
        this.datosTerritorio.valueAldia != 0 &&
        this.datosTerritorio.targetAldia != 0
      ) {
        this.valores2.filtros.value = this.datosTerritorio.valueAldia;
        this.valores2.filtros.target = this.datosTerritorio.targetAldia;
        this.valores2.filtros.rColores = this.colores;
        this.valores2.filtros.rCalf = this.rangos;
        this.$refs.barraHorizontal.setValores(this.valores2.filtros);
      }
      if (
        this.datosTerritorio.rangoSemanas != null &&
        this.datosTerritorio.rangoSemanas.length > 0
      ) {
        this.cargaServiciosSemanal();
      }
      this.cargaSemanaUsuario();
    },
    cargaSemanaUsuario() {
      //Usuario (Semanal)
      let url = "/asignacion-mtto/secure/get/semanaUsuario";
      axios
        .post(url, this.fechasTrimestral)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              console.log("semanaUsuario\n" + JSON.stringify(data));
              //this.preparaGraficaSemanal(data);
              console.log("Llamando Set Valores:" + this.rangos);

              this.$refs.tablaUsuariosSemanales.setValores(
                data,
                this.fechasTrimestral.fechaInicio,
                this.fechasTrimestral.fechaFin,
                this.paramsNivel_2
              );
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    cargaServiciosSemanal() {
      //Grafico 3 (Semanal)
      let url = "/asignacion-mtto/secure/get/semanaTerritorio";
      axios
        .post(url, this.fechasTrimestral)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              console.log("semanaTerritorio\n" + JSON.stringify(data));
              this.preparaGraficaSemanal(data);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    preparaGraficaSemanal(data) {
      this.valores3.filtros.datos = [];

      for (var i = 0; i < this.datosTerritorio.rangoSemanas.length; i++) {
        var elemento = undefined;
        var elem = [];
        if (data != undefined) {
          elemento = data
            .filter(
              (dato) => dato.semana == this.datosTerritorio.rangoSemanas[i]
            )
            .find(
              (newDato) =>
                newDato.idTerritorio == this.datosTerritorio.idTerritorio
            );
        }
        if (elemento == undefined) {
          elem = [
            {
              semana: "" + this.datosTerritorio.rangoSemanas[i] + "",
              programacion: 0,
              realizado: 0,
            },
          ];
        } else {
          elem = [
            {
              semana: "" + this.datosTerritorio.rangoSemanas[i] + "",
              programacion: elemento.conteoProgramadas,
              realizado: elemento.conteoRealizadas,
            },
          ];
        }
        this.valores3.filtros.datos = this.valores3.filtros.datos.concat(elem);
      }
      this.$refs.barraComparativaSemana.setValores(this.valores3.filtros);
    },
    downExcel() {
      //DATA PARA DESCARGAR
      let objAdd = {
        fechaInicio: this.fechasTrimestral.fechaInicio,
        fechaFin: this.fechasTrimestral.fechaFin,
        territorio: this.datosTerritorio.idTerritorio,
      };

      axios
        .post("/asignacion-mtto/secure/get/reporteProgramadas", objAdd)
        .then((response) => {
          if (response) {
            if (response.status === 200) {
              console.log(JSON.stringify(response.data.data));

              const dataFinal = this.crearInfoExcel(response.data.data);

              axios({
                method: "post",
                url: "/json/convert/secure/array/excel",
                responseType: "blob",
                data: dataFinal,
              })
                .then((response) => {
                  //console.log("La data:" + response.data)

                  if (response.headers["content-type"] !== "application/json") {
                    FileSaver.saveAs(
                      response.data,
                      response.headers["file-name"]
                    );
                  }
                })
                .catch((error) => {
                  console.log(error);
                })
                .finally(function() {});

              if ("undefined" == typeof response.data.data) {
                alert("FALLO MORTAL");
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    crearInfoExcel(data) {
      let datos = data;

      let xlsInfo = [];
      let fields = [
        //  0-Header Excel    1-Dato desde DB
        ["TERRITORIO", "territorio"],
        ["ZONA", "zona"],
        ["CECO", "idCeco"],
        ["NOMBRE_CECO", "nombreCeco"],
        ["USUARIO", "idUsuario"],
        ["NOMBRE_USUARIO", "nombreUsuario"],
        ["ESTATUS", "estatus"],
        ["FECHA_PROGRAMADA", "fechaProgramada"],
        //["FECHA_REALIZADA", "fechaRealizada"]
      ];
      for (var i = 0; i < data.length; i++) {
        let ass = new Object();
        for (var j = 0; j < fields.length; j++) {
          let instrucc =
            "ass." +
            fields[j][0] +
            " = typeof(datos[i]." +
            fields[j][1] +
            ") == 'undefined' ? '' : " +
            "datos[i]." +
            fields[j][1];
          eval(instrucc);
        }
        xlsInfo.push(ass);
      }
      return xlsInfo;
    },
    setSemaforo(methodsSemaforo) {
      this.methodsSemaforo = methodsSemaforo;
    },
  },

  mounted() {
    this.$root.$on("rangoloaded", this.setSemaforo);
    this.iniciaGrafica();
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
  },
  created() {
    if (this.$route.params.parametros) {
      let parametros = this.serviceCommons.base64ToObject(
        this.$route.params.parametros
      );
      this.fechasTrimestral.fechaInicio = parametros.fechaInicio;
      this.fechasTrimestral.fechaFin = parametros.fechaFin;
      this.fechasTrimestral.territorio = parametros.idTerritorio;
      this.datosTerritorio.territorio = parametros.territorio;
      this.datosTerritorio.idTerritorio = parametros.idTerritorio;
      this.datosTerritorio.responsable = parametros.responsable;
      this.datosTerritorio.valueTrimestre = parametros.valueTrimestre;
      this.datosTerritorio.targetTrimestre = parametros.targetTrimestre;
      this.datosTerritorio.valueAldia = parametros.valueAldia;
      this.datosTerritorio.targetAldia = parametros.targetAldia;
      this.datosTerritorio.rangoSemanas = JSON.parse(parametros.rangoSemanas);
      this.rangos = JSON.parse(parametros.rangos);
      this.colores = JSON.parse(parametros.colores);
    }
    /*
        if (this.$route.params.fechaInicio) {  this.fechasTrimestral.fechaInicio =this.$route.params.fechaInicio; }
        if (this.$route.params.fechaFin) {  this.fechasTrimestral.fechaFin =this.$route.params.fechaFin; }
        if (this.$route.params.idTerritorio) {  this.fechasTrimestral.territorio =this.$route.params.idTerritorio; }
        if (this.$route.params.territorio) {  this.datosTerritorio.territorio =this.$route.params.territorio; }
        if (this.$route.params.idTerritorio) {  this.datosTerritorio.idTerritorio =this.$route.params.idTerritorio; }
        //if (this.$route.params.responsable) {  this.datosTerritorio.responsable =this.$route.params.responsable; }
        if (this.$route.params.valueTrimestre) {  this.datosTerritorio.valueTrimestre =this.$route.params.valueTrimestre; }
        if (this.$route.params.targetTrimestre) {  this.datosTerritorio.targetTrimestre =this.$route.params.targetTrimestre; }
        if (this.$route.params.valueAldia) {  this.datosTerritorio.valueAldia =this.$route.params.valueAldia; }
        if (this.$route.params.targetAldia) {  this.datosTerritorio.targetAldia =this.$route.params.targetAldia; }
        if (this.$route.params.rangoSemanas) {this.datosTerritorio.rangoSemanas = JSON.parse(this.$route.params.rangoSemanas);}
        if (this.$route.params.rangos) {  this.rangos = JSON.parse(this.$route.params.rangos); }
        if (this.$route.params.colores) {  this.colores = JSON.parse( this.$route.params.colores ); }
        */
    let paramsNivel_2_ = {
      fechaInicio: this.$route.params.fechaInicio,
      fechaFin: this.$route.params.fechaFin,
      idTerritorio: this.$route.params.idTerritorio,
      territorio: this.$route.params.territorio,
      responsable: this.$route.params.responsable,
      valueTrimestre: this.$route.params.valueTrimestre,
      targetTrimestre: this.$route.params.targetTrimestre,
      valueAldia: this.$route.params.valueAldia,
      targetAldia: this.$route.params.targetAldia,
      rangoSemanas: this.$route.params.rangoSemanas,
      rangos: this.$route.params.rangos,
    };

    this.paramsNivel_2 = JSON.stringify(paramsNivel_2_);
    console.log("Creado this-paramsNivel-2:" + this.paramsNivel_2);
    console.log("ValueTrimestre de URL:" + this.$route.params.valueTrimestre);
  },
};
</script>
